import React, { ComponentType, ReactNode, Dispatch, SetStateAction } from 'react';
import { ComponentModel } from '@teambit/component';
export declare type ComponentFilters = Array<ComponentFilterCriteria<any>>;
export declare type ComponentFilterCriteria<State> = {
    id: string;
    render: ComponentType<{
        components: ComponentModel[];
    } & React.HTMLAttributes<HTMLDivElement>>;
    match: (component: ComponentModel, state: State) => boolean;
    state: State;
    order?: number;
};
export declare type ComponentFilterContextType = {
    filters: ComponentFilters;
    setFilters: React.Dispatch<React.SetStateAction<ComponentFilters>>;
};
export declare const ComponentFilterContext: React.Context<ComponentFilterContextType>;
export declare function useComponentFilter<T>(filter: ComponentFilterCriteria<T>, defaultState?: T): [ComponentFilterCriteria<T>, Dispatch<SetStateAction<ComponentFilterCriteria<T>>>] | undefined;
export declare const ComponentFiltersProvider: ({ children, filters, }: {
    children: ReactNode;
    filters?: ComponentFilters;
}) => JSX.Element;
export declare const runAllFilters: (filters: ComponentFilters, components: ComponentModel[]) => ComponentModel[];
