"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeprecateFilter = void 0;
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importDefault(require("react"));
const design_ui_input_toggle_1 = require("@teambit/design.ui.input.toggle");
const component_filters_context_1 = require("./component-filters.context");
const deprecate_filter_module_scss_1 = __importDefault(require("./deprecate-filter.module.scss"));
exports.DeprecateFilter = {
    id: 'deprecate',
    match: (component, active) => { var _a; return active || !((_a = component.deprecation) === null || _a === void 0 ? void 0 : _a.isDeprecate); },
    state: false,
    order: 0,
    render: deprecateFilter,
};
function deprecateFilter({ className }) {
    const filterContext = (0, component_filters_context_1.useComponentFilter)(exports.DeprecateFilter);
    if (!filterContext)
        return null;
    const [filter, updateFilter] = filterContext;
    const isActive = filter.state;
    return (react_1.default.createElement("div", { className: (0, classnames_1.default)(deprecate_filter_module_scss_1.default.deprecateFilter, isActive && deprecate_filter_module_scss_1.default.active, className) },
        react_1.default.createElement("div", { className: deprecate_filter_module_scss_1.default.filterIcon },
            react_1.default.createElement("img", { src: "https://static.bit.dev/bit-icons/deprecated.svg" }),
            react_1.default.createElement("span", { className: deprecate_filter_module_scss_1.default.filterIconLabel }, "Deprecated")),
        react_1.default.createElement("div", null,
            react_1.default.createElement(design_ui_input_toggle_1.Toggle, { checked: isActive, onInputChanged: () => updateFilter((currentState) => (Object.assign(Object.assign({}, currentState), { state: !isActive }))) }))));
}
//# sourceMappingURL=deprecate-filter.js.map