"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EnvsFilter = void 0;
const react_1 = __importStar(require("react"));
const design_inputs_selectors_multi_select_1 = require("@teambit/design.inputs.selectors.multi-select");
const component_1 = require("@teambit/component");
const component_modules_component_url_1 = require("@teambit/component.modules.component-url");
const classnames_1 = __importDefault(require("classnames"));
const design_ui_styles_ellipsis_1 = require("@teambit/design.ui.styles.ellipsis");
const design_ui_tooltip_1 = require("@teambit/design.ui.tooltip");
const base_react_navigation_link_1 = require("@teambit/base-react.navigation.link");
const component_filters_context_1 = require("./component-filters.context");
const envs_filter_module_scss_1 = __importDefault(require("./envs-filter.module.scss"));
exports.EnvsFilter = {
    id: 'envs',
    match: (component, filter) => {
        var _a;
        const { envsState } = filter;
        const activeEnvs = [...envsState.values()].filter((envState) => envState.active).map((envState) => envState.id);
        // match everything when no envs are set
        if (activeEnvs.length === 0)
            return true;
        const envId = component.environment && ((_a = component_1.ComponentID.tryFromString(component.environment.id)) === null || _a === void 0 ? void 0 : _a.toStringWithoutVersion());
        const matches = !!envId && activeEnvs.indexOf(envId) >= 0;
        return matches;
    },
    state: {
        envsState: new Map(),
        dropdownState: false,
    },
    order: 1,
    render: envsFilter,
};
const getDefaultState = (components) => {
    return (0, react_1.useMemo)(() => {
        const defaultState = {
            dropdownState: false,
            envsState: new Map(),
        };
        const componentEnvSet = new Set();
        const componentsEnvsWithIcons = components
            .filter((component) => {
            const envId = component.environment && component_1.ComponentID.tryFromString(component.environment.id);
            if (!envId)
                return false;
            const envKey = envId.toStringWithoutVersion();
            if (componentEnvSet.has(envKey))
                return false;
            componentEnvSet.add(envKey);
            return true;
        })
            .map((component) => {
            var _a, _b;
            const envId = component_1.ComponentID.fromString((_a = component.environment) === null || _a === void 0 ? void 0 : _a.id);
            return {
                displayName: envId.name,
                id: envId.toStringWithoutVersion(),
                description: `${envId.scope}${envId.namespace ? '/'.concat(envId.namespace) : ''}`,
                icon: (_b = component.environment) === null || _b === void 0 ? void 0 : _b.icon,
                componentId: envId,
            };
        });
        componentsEnvsWithIcons.forEach((componentEnvWithIcon) => {
            defaultState.envsState.set(componentEnvWithIcon.id, Object.assign(Object.assign({}, componentEnvWithIcon), { active: true }));
        });
        return defaultState;
    }, [components]);
};
function envsFilter({ components, className, }) {
    const defaultState = getDefaultState(components);
    const filterContext = (0, component_filters_context_1.useComponentFilter)(exports.EnvsFilter, defaultState);
    if (!filterContext)
        return null;
    const [currentFilter, updateFilter] = filterContext;
    const currentEnvsState = currentFilter.state.envsState;
    const selectList = [];
    currentFilter.state.envsState.forEach((state) => {
        var _a;
        selectList.push({
            value: state.id,
            icon: state.icon,
            description: state.description,
            checked: !!((_a = currentEnvsState.get(state.id)) === null || _a === void 0 ? void 0 : _a.active),
            element: react_1.default.createElement(EnvsDropdownItem, Object.assign({}, state)),
        });
    });
    const onCheck = (value, e) => {
        const checked = e.target.checked;
        updateFilter((currentState) => {
            if (checked && !currentState.state.dropdownState) {
                currentState.state.dropdownState = true;
            }
            const currentEnvState = currentState.state.envsState.get(value);
            if (!currentEnvState)
                return currentState;
            currentState.state.envsState.set(value, Object.assign(Object.assign({}, currentEnvState), { active: checked }));
            return currentState;
        });
    };
    const onClear = () => {
        updateFilter((currentState) => {
            currentState.state.envsState.forEach((value, key) => {
                currentState.state.envsState.set(key, Object.assign(Object.assign({}, value), { active: false }));
            });
            return currentState;
        });
    };
    const onSubmit = () => {
        updateFilter((currentState) => {
            currentState.state.dropdownState = false;
            return currentState;
        });
    };
    const onDropdownToggled = (event, open) => {
        updateFilter((currentState) => {
            currentState.state.dropdownState = open;
            return currentState;
        });
    };
    return (react_1.default.createElement("div", { className: (0, classnames_1.default)(envs_filter_module_scss_1.default.envsFilterContainer, className) },
        react_1.default.createElement(design_inputs_selectors_multi_select_1.MultiSelect, { itemsList: selectList, placeholder: react_1.default.createElement(EnvsPlaceholder, null), onSubmit: onSubmit, onCheck: onCheck, onClear: onClear, onChange: onDropdownToggled, open: currentFilter.state.dropdownState, dropdownBorder: false, className: envs_filter_module_scss_1.default.envFilterDropdownContainer, dropClass: envs_filter_module_scss_1.default.envFilterDropdown })));
}
function EnvsPlaceholder() {
    return (react_1.default.createElement("div", { className: envs_filter_module_scss_1.default.filterIcon },
        react_1.default.createElement("img", { src: "https://static.bit.dev/bit-icons/env.svg" }),
        react_1.default.createElement("span", { className: envs_filter_module_scss_1.default.filterIconLabel }, "Environments"),
        react_1.default.createElement("div", { className: envs_filter_module_scss_1.default.dropdownArrow },
            react_1.default.createElement("img", { src: "https://static.bit.dev/bit-icons/fat-arrow-down.svg" }))));
}
function EnvsDropdownItem({ displayName, icon, description, componentId, id }) {
    return (react_1.default.createElement(design_ui_tooltip_1.Tooltip, { placement: "right", content: react_1.default.createElement(base_react_navigation_link_1.Link, { className: envs_filter_module_scss_1.default.envLink, href: component_modules_component_url_1.ComponentUrl.toUrl(componentId, { includeVersion: false }), external: true }, id) },
        react_1.default.createElement("div", { className: envs_filter_module_scss_1.default.envDropdownItemContainer },
            react_1.default.createElement("div", { className: envs_filter_module_scss_1.default.envDropdownItem },
                react_1.default.createElement(design_ui_styles_ellipsis_1.Ellipsis, null, displayName),
                react_1.default.createElement("div", { className: envs_filter_module_scss_1.default.envDropdownItemIconContainer },
                    react_1.default.createElement("img", { className: envs_filter_module_scss_1.default.envDropdownItemIcon, src: icon }))),
            react_1.default.createElement("div", { className: envs_filter_module_scss_1.default.description },
                react_1.default.createElement(design_ui_styles_ellipsis_1.Ellipsis, { className: envs_filter_module_scss_1.default.descriptionText }, description)))));
}
//# sourceMappingURL=envs-filter.js.map